// Programmer data exchange block
// V1.6 07-06-2001
// (c) CnC Lab

#ifdef LINUXXX
# define far
#endif

#ifndef _TYPES
typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long dword;
#define _TYPES
#endif

#define DLLVERSION 6

//  㭪権 :
#define DFN_LOAD      0
#define DFN_INIT      1
#define DFN_FREAD     2
#define DFN_FCOMPARE  3
#define DFN_FBLANK    4
#define DFN_FWRITE    5
#define DFN_EXAMWR    6
#define DFN_ERASE     7
#define DFN_READID    8
#define DFN_TEST      9
#define DFN_LOCK      10
#define DFN_UNLOCK    11


//  Message box classes
enum {
    dmfWarning      = 0x0000,       // Display a Warning box
    dmfError        = 0x0001,       // Dispaly a Error box
    dmfInformation  = 0x0002,       // Display an Information Box
    dmfConfirmation = 0x0003,       // Display a Confirmation Box
// Message box button flags
    dmfYesButton    = 0x0100,       // Put a Yes button into the dialog
    dmfNoButton     = 0x0200,       // Put a No button into the dialog
    dmfOKButton     = 0x0400,       // Put an OK button into the dialog
    dmfCancelButton = 0x0800        // Put a Cancel button into the dialog
};
// Message box button return codes
enum {
    dcmOK            = 10,
    dcmCancel        = 11,
    dcmYes           = 12,
    dcmNo            = 13,
    dcmDefault       = 14
};

typedef struct CFGKEY
{
  byte  type;     //⨯ - 'Dd/Hh/Bb' ( 㪢 - ।㥬)
  byte  name[13]; //
  dword data;     //⥪饥 祭
  dword deflt;    //祭  㬮砭
  dword maxlim;   //ᨬ쭮 祭
} CFGKEY;

//    묨  㫥
typedef struct DLLDATA
{
  word  funcode;    //  㭪樨 
  word  subfcode;   //  㭪樨
  dword esize;      // ꥬ EPROM (᫮)
  byte  ewide;      // ࠧ來 EPROM ()
  dword adr;        //  ⥭/
  dword edata;      // 
  byte  far * name; //  稯
  byte  curalg;     // ⥪騩   ()
  byte  forcewr;    // 䫠 ਭ㤨⥫쭮 
  byte  checkwr;    // 䫠 ஢ન 
  byte  testins;    // 䫠 ஢ન ⠭ 奬
  word  Vcc,Vccmax; // 殮 ⠭ (⥭) *100 mV
  word  Vpp,Vppmax; // 殮 ணࠬ஢ *100 mV
  word  Vid,Vidmax; // 殮 ID *100 mV
  word far * VccTable;  // 殮  ࠩ
  word far * VppTable;
  word far * VidTable;
  byte reserved[32];

//  㭪権, ᯮ㥬 㫥:
  word (far * bdprt) (word cmd);                    // hardware ࠩ
  void (far * mcsdelay) (dword t);                   // প ()
  byte (far * getbytebuf) (dword adr);               // ⥭   
  int  (far * setbytebuf) (dword adr, byte data);    //    
  byte far* (far * getpage) (dword adr, dword size); //  ࠭ 
  int (far * getbmark) (dword adr);                  //  ⬥ 
  void (far * setbmark) (dword adr, int state);      // ⠭ ⬥ 
  int  (far * iprogress) (dword adr,word mode);      // :
                                                     //  mode=0 - init,     mode=1 - close
                                                     //  mode=2 - progress, mode=3 - text
  int  (far * voltage) (word Vcc,word Vpp,word Vid); // ⠭ 殮
  word (far * msgBox) (word aOptions, char far* msg,... );  //  ᮮ饭

//  㫥  樠樨:
  word funmask[16];            // ᪠ 㭪権, ࠡ뢠 㫥
  dword defstate;              // 砫쭮 ﭨ ⮩ ROM
  byte dippins;                //    DIP
  byte version;                //  
  byte far * copyright;        //  ଠ樮 ப
  CFGKEY far * cfgkeys;        //  ⥫ 祩
} DLLDATA;

extern DLLDATA far * dllp;
extern int (far * dllfun)(void);
